package org.zeroturnaround.demoApps.servlet3;

import java.io.IOException;
import java.net.URL;
import java.util.Set;

import javax.servlet.Servlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;


public class MyServlet implements Servlet {

  
  public void destroy() {    
  }
  
  public ServletConfig getServletConfig() {
    return null;
  }

  public String getServletInfo() {
    return null;
  }

  public void init(ServletConfig arg0) throws ServletException {
    System.out.println("======== INITING SERVLET");
    
  }

  public void service(ServletRequest request, ServletResponse response) throws ServletException, IOException {
    
    ServletContext sc = request.getServletContext(); 
    String a = sc.getRealPath("/webstart/test.txt");
    String b = sc.getRealPath("/META-INF/resources/webstart/test.txt");
    
    URL c = sc.getResource("/webstart/test.txt");
    URL d = sc.getResource("/META-INF/resources/webstart/test.txt");
    
    // Can we reach /webstart/test.txt if we go through resources recursively?
    //sc.getResourcePaths("/");
    echo(" ======= GETTING PATHS FOR /");
    getPathsRecursive("/", sc);
    
    echo("\n\n");
    
    echo(" ======= GETTING PATHS FOR /webstart");
    getPathsRecursive("/webstart", sc);
    
    response.getWriter().write("kim jong-il");
    
  }
  
  
  private void getPathsRecursive(String parentPath, ServletContext sc) {
    System.out.println(" ------- paths for: " + parentPath);
    
    Set<String> paths = sc.getResourcePaths(parentPath);
    if (paths != null) {
      for (String path : paths) {
        echo("=> " + path);
      }
    }
    
    //echo("  ====> " + setToString(paths));
    
    for (String childResource : paths) {
      getPathsRecursive(childResource, sc);
    }
  }
  

  private String setToString(Set<String> set) {
    StringBuilder sb = new StringBuilder();
    sb.append("[ ");
    for (String s : set) {
      sb.append( s + " , ");
    }
    sb.append(" ]");
    return sb.toString();
  }

  
  private static void echo(Object o) {
    System.out.println(o);
  }
  
}
